osg::Switch Class Reference

`#include <Switch>`

Inheritance diagram for osg::Switch:

## Public Types

typedef std::vector< bool > | ValueList
Public Types inherited from osg::Node
typedef std::vector< Group * > | ParentList
typedef unsigned int | NodeMask
typedef std::vector< std::string > | DescriptionList
Public Types inherited from osg::Object
enum | DataVariance { DYNAMIC , STATIC , UNSPECIFIED }

## Public Member Functions

| Switch ()
| Switch (const Switch &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
virtual Switch * | asSwitch ()
virtual const Switch * | asSwitch () const
| META_Node (osg, Switch)
virtual void | traverse (NodeVisitor &nv)
void | setNewChildDefaultValue (bool value)
bool | getNewChildDefaultValue () const
virtual bool | addChild (Node *child)
virtual bool | addChild (Node *child, bool value)
virtual bool | insertChild (unsigned int index, Node *child)
virtual bool | insertChild (unsigned int index, Node *child, bool value)
virtual bool | removeChildren (unsigned int pos, unsigned int numChildrenToRemove)
void | setValue (unsigned int pos, bool value)
bool | getValue (unsigned int pos) const
void | setChildValue (const Node *child, bool value)
bool | getChildValue (const Node *child) const
bool | setAllChildrenOff ()
bool | setAllChildrenOn ()
bool | setSingleChildOn (unsigned int pos)
void | setValueList (const ValueList &values)
const ValueList & | getValueList () const
virtual BoundingSphere | computeBound () const
template<class T>
bool | addChild (const ref_ptr< T > &child)
template<class T>
bool | insertChild (unsigned int index, const ref_ptr< T > &child)
Public Member Functions inherited from osg::Group
| Group ()
| Group (const Group &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
| META_Node (osg, Group)
virtual Group * | asGroup ()
virtual const Group * | asGroup () const
template<class T>
bool | addChild (const ref_ptr< T > &child)
template<class T>
bool | insertChild (unsigned int index, const ref_ptr< T > &child)
virtual bool | removeChild (Node *child)
template<class T>
bool | removeChild (const ref_ptr< T > &child)
bool | removeChild (unsigned int pos, unsigned int numChildrenToRemove=1)
virtual bool | replaceChild (Node *origChild, Node *newChild)
template<class T, class R>
bool | replaceChild (const ref_ptr< T > &origChild, const ref_ptr< R > &newChild)
virtual unsigned int | getNumChildren () const
virtual bool | setChild (unsigned int i, Node *node)
Node * | getChild (unsigned int i)
const Node * | getChild (unsigned int i) const
bool | containsNode (const Node *node) const
template<class T>
bool | containsNode (const ref_ptr< T > &node) const
unsigned int | getChildIndex (const Node *node) const
virtual void | setThreadSafeRefUnref (bool threadSafe)
virtual void | resizeGLObjectBuffers (unsigned int maxSize)
virtual void | releaseGLObjects (osg::State *=0) const
Public Member Functions inherited from osg::Node
| Node ()
| Node (const Node &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
virtual Object * | cloneType () const
virtual Object * | clone (const CopyOp &copyop) const
virtual bool | isSameKindAs (const Object *obj) const
virtual const char * | libraryName () const
virtual const char * | className () const
virtual Node * | asNode ()
virtual const Node * | asNode () const
virtual Drawable * | asDrawable ()
virtual const Drawable * | asDrawable () const
virtual Geometry * | asGeometry ()
virtual const Geometry * | asGeometry () const
virtual Transform * | asTransform ()
virtual const Transform * | asTransform () const
virtual Geode * | asGeode ()
virtual const Geode * | asGeode () const
virtual osgTerrain::Terrain * | asTerrain ()
virtual const osgTerrain::Terrain * | asTerrain () const
virtual void | accept (NodeVisitor &nv)
virtual void | ascend (NodeVisitor &nv)
const ParentList & | getParents () const
ParentList | getParents ()
Group * | getParent (unsigned int i)
const Group * | getParent (unsigned int i) const
unsigned int | getNumParents () const
NodePathList | getParentalNodePaths (osg::Node *haltTraversalAtNode=0) const
MatrixList | getWorldMatrices (const osg::Node *haltTraversalAtNode=0) const
void | setUpdateCallback (Callback *nc)
template<class T>
void | setUpdateCallback (const ref_ptr< T > &nc)
Callback * | getUpdateCallback ()
const Callback * | getUpdateCallback () const
void | addUpdateCallback (Callback *nc)
template<class T>
void | addUpdateCallback (const ref_ptr< T > &nc)
void | removeUpdateCallback (Callback *nc)
template<class T>
void | removeUpdateCallback (const ref_ptr< T > &nc)
unsigned int | getNumChildrenRequiringUpdateTraversal () const
void | setEventCallback (Callback *nc)
template<class T>
void | setEventCallback (const ref_ptr< T > &nc)
Callback * | getEventCallback ()
const Callback * | getEventCallback () const
void | addEventCallback (Callback *nc)
template<class T>
void | addEventCallback (const ref_ptr< T > &nc)
void | removeEventCallback (Callback *nc)
template<class T>
void | removeEventCallback (const ref_ptr< T > &nc)
unsigned int | getNumChildrenRequiringEventTraversal () const
void | setCullCallback (Callback *nc)
template<class T>
void | setCullCallback (const ref_ptr< T > &nc)
Callback * | getCullCallback ()
const Callback * | getCullCallback () const
void | addCullCallback (Callback *nc)
template<class T>
void | addCullCallback (const ref_ptr< T > &nc)
void | removeCullCallback (Callback *nc)
template<class T>
void | removeCullCallback (const ref_ptr< T > &nc)
void | setCullingActive (bool active)
bool | getCullingActive () const
unsigned int | getNumChildrenWithCullingDisabled () const
bool | isCullingActive () const
unsigned int | getNumChildrenWithOccluderNodes () const
bool | containsOccluderNodes () const
void | setNodeMask (NodeMask nm)
NodeMask | getNodeMask () const
void | setStateSet (osg::StateSet *stateset)
template<class T>
void | setStateSet (const osg::ref_ptr< T > &stateset)
osg::StateSet * | getOrCreateStateSet ()
osg::StateSet * | getStateSet ()
const osg::StateSet * | getStateSet () const
void | setDescriptions (const DescriptionList &descriptions)
DescriptionList & | getDescriptions ()
const DescriptionList & | getDescriptions () const
const std::string & | getDescription (unsigned int i) const
std::string & | getDescription (unsigned int i)
unsigned int | getNumDescriptions () const
void | addDescription (const std::string &desc)
void | setInitialBound (const osg::BoundingSphere &bsphere)
const BoundingSphere & | getInitialBound () const
void | dirtyBound ()
const BoundingSphere & | getBound () const
void | setComputeBoundingSphereCallback (ComputeBoundingSphereCallback *callback)
template<class T>
void | setComputeBoundingSphereCallback (const ref_ptr< T > &callback)
ComputeBoundingSphereCallback * | getComputeBoundingSphereCallback ()
const ComputeBoundingSphereCallback * | getComputeBoundingSphereCallback () const
Public Member Functions inherited from osg::Object
| Object ()
| Object (bool threadSafeRefUnref)
| Object (const Object &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
std::string | getCompoundClassName () const
virtual NodeVisitor * | asNodeVisitor ()
virtual const NodeVisitor * | asNodeVisitor () const
virtual StateSet * | asStateSet ()
virtual const StateSet * | asStateSet () const
virtual StateAttribute * | asStateAttribute ()
virtual const StateAttribute * | asStateAttribute () const
virtual Uniform * | asUniform ()
virtual const Uniform * | asUniform () const
virtual Camera * | asCamera ()
virtual const Camera * | asCamera () const
virtual Callback * | asCallback ()
virtual const Callback * | asCallback () const
virtual CallbackObject * | asCallbackObject ()
virtual const CallbackObject * | asCallbackObject () const
virtual UserDataContainer * | asUserDataContainer ()
virtual const UserDataContainer * | asUserDataContainer () const
virtual ValueObject * | asValueObject ()
virtual const ValueObject * | asValueObject () const
virtual Image * | asImage ()
virtual const Image * | asImage () const
virtual void | setName (const std::string &name)
void | setName (const char *name)
const std::string & | getName () const
void | setDataVariance (DataVariance dv)
DataVariance | getDataVariance () const
virtual void | computeDataVariance ()
void | setUserDataContainer (osg::UserDataContainer *udc)
template<class T>
void | setUserDataContainer (const ref_ptr< T > &udc)
osg::UserDataContainer * | getUserDataContainer ()
const osg::UserDataContainer * | getUserDataContainer () const
osg::UserDataContainer * | getOrCreateUserDataContainer ()
virtual void | setUserData (Referenced *obj)
template<class T>
void | setUserData (const ref_ptr< T > &ud)
virtual Referenced * | getUserData ()
virtual const Referenced * | getUserData () const
template<typename T>
bool | getUserValue (const std::string &name, T &value) const
template<typename T>
void | setUserValue (const std::string &name, const T &value)
template<typename T>
BoolValueObject UCharValueObject UShortValueObject UIntValueObject DoubleValueObject Vec3fValueObject Vec2dValueObject Vec4dValueObject PlaneValueObject MatrixdValueObject BoundingBoxdValueObject BoundingSpheredValueObject bool | getUserValue (const std::string &name, T &value) const
Public Member Functions inherited from osg::Referenced
| Referenced ()
| Referenced (bool threadSafeRefUnref)
| Referenced (const Referenced &)
Referenced & | operator= (const Referenced &)
bool | getThreadSafeRefUnref () const
OpenThreads::Mutex * | getRefMutex () const
int | ref () const
int | unref () const
int | unref_nodelete () const
int | referenceCount () const
ObserverSet * | getObserverSet () const
ObserverSet * | getOrCreateObserverSet () const
void | addObserver (Observer *observer) const
void | removeObserver (Observer *observer) const

## Protected Member Functions

virtual | ~Switch ()
Protected Member Functions inherited from osg::Group
virtual | ~Group ()
virtual void | childRemoved (unsigned int, unsigned int)
virtual void | childInserted (unsigned int)
Protected Member Functions inherited from osg::Node
virtual | ~Node ()
void | addParent (osg::Group *parent)
void | removeParent (osg::Group *parent)
void | setNumChildrenRequiringUpdateTraversal (unsigned int num)
void | setNumChildrenRequiringEventTraversal (unsigned int num)
void | setNumChildrenWithCullingDisabled (unsigned int num)
void | setNumChildrenWithOccluderNodes (unsigned int num)
Protected Member Functions inherited from osg::Object
virtual | ~Object ()
Protected Member Functions inherited from osg::Referenced
virtual | ~Referenced ()
void | signalObserversAndDelete (bool signalDelete, bool doDelete) const
void | deleteUsingDeleteHandler () const

## Protected Attributes

bool | _newChildDefaultValue
ValueList | _values
Protected Attributes inherited from osg::Group
NodeList | _children
Protected Attributes inherited from osg::Node
BoundingSphere | _initialBound
ref_ptr< ComputeBoundingSphereCallback > | _computeBoundCallback
BoundingSphere | _boundingSphere
bool | _boundingSphereComputed
ParentList | _parents
ref_ptr< Callback > | _updateCallback
unsigned int | _numChildrenRequiringUpdateTraversal
ref_ptr< Callback > | _eventCallback
unsigned int | _numChildrenRequiringEventTraversal
ref_ptr< Callback > | _cullCallback
bool | _cullingActive
unsigned int | _numChildrenWithCullingDisabled
unsigned int | _numChildrenWithOccluderNodes
NodeMask | _nodeMask
ref_ptr< StateSet > | _stateset
Protected Attributes inherited from osg::Object
std::string | _name
DataVariance | _dataVariance
osg::UserDataContainer * | _userDataContainer
Protected Attributes inherited from osg::Referenced
OpenThreads::AtomicPtr | _observerSet
OpenThreads::Atomic | _refCount

## Additional Inherited Members

Static Public Member Functions inherited from osg::Referenced
static OpenThreads::Mutex * | getGlobalReferencedMutex ()
static void | setDeleteHandler (DeleteHandler *handler)
static DeleteHandler * | getDeleteHandler ()

## Detailed Description

Switch is a Group node that allows switching between children. Typical uses would be for objects which might need to be rendered differently at different times, for instance a switch could be used to represent the different states of a traffic light.

## Member Typedef Documentation

## ValueList

typedef std::vector<bool> osg::Switch::ValueList

## Constructor & Destructor Documentation

## Switch() [1/2]

osg::Switch::Switch | ( |  | ) |

Referenced by asSwitch(), asSwitch(), META_Node(), and Switch().

## Switch() [2/2]

osg::Switch::Switch | ( | const Switch & | ,
|  | const CopyOp & | copyop = CopyOp::SHALLOW_COPY )

Copy constructor using CopyOp to manage deep vs shallow copy.

References osg::CopyOp::SHALLOW_COPY, and Switch().

## ~Switch()

virtual osg::Switch::~Switch | ( |  | ) |

inline protected virtual

## Member Function Documentation

## addChild() [1/3]

template<class T>

bool osg::Group::addChild | ( | const ref_ptr< T > & | child | ) |

inline

## addChild() [2/3]

virtual bool osg::Switch::addChild | ( | Node * | child | ) |

virtual

Add Node to Group. If node is not NULL then increment its reference count, add it to the child list and dirty the bounding sphere to force it to recompute on next getBound() and return true for success. Otherwise return false. Scene nodes can't be added as child nodes.

Reimplemented from osg::Group.

## addChild() [3/3]

virtual bool osg::Switch::addChild | ( | Node * | child,
|  | bool | value )

virtual

## asSwitch() [1/2]

virtual Switch * osg::Switch::asSwitch | ( |  | ) |

inline virtual

Convert 'this' into a Switch pointer if Node is a Switch, otherwise return 0. Equivalent to dynamic_cast<Switch*>(this).

Reimplemented from osg::Node.

References Switch().

## asSwitch() [2/2]

virtual const Switch * osg::Switch::asSwitch | ( |  | ) | const

inline virtual

convert 'const this' into a const Switch pointer if Node is a Switch, otherwise return 0. Equivalent to dynamic_cast<const Switch*>(this).

Reimplemented from osg::Node.

References Switch().

## computeBound()

virtual BoundingSphere osg::Switch::computeBound | ( |  | ) | const

virtual

Compute the bounding sphere around Node's geometry or children. This method is automatically called by getBound() when the bounding sphere has been marked dirty via dirtyBound().

Reimplemented from osg::Group.

## getChildValue()

bool osg::Switch::getChildValue | ( | const Node * | child | ) | const

## getNewChildDefaultValue()

bool osg::Switch::getNewChildDefaultValue | ( |  | ) | const

inline

References _newChildDefaultValue.

## getValue()

bool osg::Switch::getValue | ( | unsigned int | pos | ) | const

## getValueList()

const ValueList & osg::Switch::getValueList | ( |  | ) | const

inline

References _values.

## insertChild() [1/3]

template<class T>

bool osg::Group::insertChild | ( | unsigned int | index,
|  | const ref_ptr< T > & | child )

inline

## insertChild() [2/3]

virtual bool osg::Switch::insertChild | ( | unsigned int | index,
|  | Node * | child )

virtual

Insert Node to Group at specific location. The new child node is inserted into the child list before the node at the specified index. No nodes are removed from the group with this operation.

Reimplemented from osg::Group.

## insertChild() [3/3]

virtual bool osg::Switch::insertChild | ( | unsigned int | index,
|  | Node * | child,
|  | bool | value )

virtual

## META_Node()

osg::Switch::META_Node | ( | osg | ,
|  | Switch | )

References Switch().

## removeChildren()

virtual bool osg::Switch::removeChildren | ( | unsigned int | pos,
|  | unsigned int | numChildrenToRemove )

virtual

Remove children from Group. Note, must be override by subclasses of Group which add per child attributes.

Reimplemented from osg::Group.

## setAllChildrenOff()

bool osg::Switch::setAllChildrenOff | ( |  | ) |

Set all the children off (false), and set the new default child value to off (false).

## setAllChildrenOn()

bool osg::Switch::setAllChildrenOn | ( |  | ) |

Set all the children on (true), and set the new default child value to on (true).

## setChildValue()

void osg::Switch::setChildValue | ( | const Node * | child,
|  | bool | value )

## setNewChildDefaultValue()

void osg::Switch::setNewChildDefaultValue | ( | bool | value | ) |

inline

References _newChildDefaultValue.

## setSingleChildOn()

bool osg::Switch::setSingleChildOn | ( | unsigned int | pos | ) |

Set a single child on, switch off all other children.

## setValue()

void osg::Switch::setValue | ( | unsigned int | pos,
|  | bool | value )

## setValueList()

void osg::Switch::setValueList | ( | const ValueList & | values | ) |

inline

References _values.

## traverse()

virtual void osg::Switch::traverse | ( | NodeVisitor & |  | ) |

virtual

Traverse downwards : calls children's accept method with NodeVisitor.

Reimplemented from osg::Group.

## Member Data Documentation

## _newChildDefaultValue

bool osg::Switch::_newChildDefaultValue

protected

Referenced by getNewChildDefaultValue(), and setNewChildDefaultValue().

## _values

ValueList osg::Switch::_values

protected

Referenced by getValueList(), and setValueList().

The documentation for this class was generated from the following file:

- Switch